# -*-coding:utf-8-*-
from amazon.api import AmazonAPI
import time
import xlrd
# AMAZON_ACCESS_KEY = "AKIAIHQECHHHBNYL6O6Q"
# AMAZON_SECRET_KEY = "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"
# AMAZON_ASSOC_TAG = "abc"
#
# amazon = AmazonAPI(AMAZON_ACCESS_KEY, AMAZON_SECRET_KEY, AMAZON_ASSOC_TAG, region='US',Timeout=10)
from sale_amazon.settings import PROJECT_DIRECTORY


def initAmazonAPI():
    path_list = PROJECT_DIRECTORY.split('/')
    print path_list
    print '/'+path_list[1]+'/'+path_list[2]+'/'+path_list[3]+'/'+path_list[4]+'/key.txt'
    global amazomApiList
    with open('/'+path_list[1]+'/'+path_list[2]+'/'+path_list[3]+'/'+path_list[4]+'/key.txt', 'r') as f:
        keys = f.readlines()
        for key in keys:
            s=key.split('\t')
            amazon = AmazonAPI(s[0], s[1], s[2][0:2], region='US',Timeout=5)
            amazomApiList.append(amazon)
    print ('初始化对象完成........')

def getById (ids):
    global k
    numOfKeys = len(amazomApiList)
    if (k==numOfKeys):
        k=0
    k = k +1
    product_list = []
    success = True
    try:
        print ('key='+str(k))
        products = amazomApiList[k-1].lookup(ItemId=ids)
        if not isinstance(products,list):
            products = [products]
        for product in products:
            images = product.images
            largeImages = []
            for image in images:
                try:
                    largeImages.append(image.LargeImage.URL)
                except AttributeError as e:
                     largeImages.append(None)

            hiResImages = []
            for image2 in images:
                try:
                    hiResImages.append(image2.HiResImage.URL)
                except AttributeError as e:
                 hiResImages.append(None)
            try:
                category = product.browse_nodes[0].id
                # ancestors = product.browse_nodes[0].ancestors
                # print ancestors[0].name.text
            except:
                category = None
            product_dict = {'asin':product.asin , 'mainImage':product.large_image_url , 'largeImage':largeImages , 'hiResImage':hiResImages , 'title':product.title , 'descrption':product.editorial_review , 'date':product.release_date , 'category':category}
            product_list.append(product_dict)
    except Exception as e:
        product_list = [{'error':e , 'id':ids}]
        success = False
    finally:
        time.sleep(0.5)
        return product_list,success

def ots(os):
    global amazomApiList,k
    amazomApiList = []
    k = 0
    initAmazonAPI()
    res,succ = getById(os)
    if succ:
        return res[0].get('category','')
    else:
        return ''


def getPathFileName(path):
    tmp = path.split('/');
    return tmp[len(tmp) - 1].split('.')[0];


def xlsToxmlPath(path):
    return path.split('.')[0] + '.xml';


def export(path):
    data = xlrd.open_workbook(path,formatting_info=True, encoding_override="utf-8")
    table = data.sheets()[0]

    f = open(xlsToxmlPath(path), 'wb')
    f.write(u'<?xml version="1.0" encoding="utf-8" ?>\n')
    f.write(u'<%s>\n' % (getPathFileName(path) + 's'))

    for i in range(1, table.nrows):
        s = u'<%s ' % getPathFileName(path);
        tmp = [u'%s = "%s"' % (str(table.cell_value(0, j)), str(table.cell_value(i, j))) for j in range(table.ncols)];
        s += u' '.join(map(str, tmp));
        s += u' />\n';
        f.write(s);

    f.write(u'</%s>' % (getPathFileName(path) + 's'));
